#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"

// This is for the Model 301 which has only 4 channels
// The following shows the usual functions required to connect and start running the multi-channel-calibration-with-digital-input scan. 
// Functions required to show the data on the console are at the bottom of the page.
// EX_SetScanType, EX_SetMultiChanScanChans, EX_SetDataLogOptions can be excluded by using "M30x_SP.ini" as described in documentation.  
BOOLEAN fWaitInit=TRUE; BOOLEAN fInitSuccess=TRUE;
int __cdecl main()
{
	// DEVELOPER NOTE: You can replace the dot-display below to a progress bar in your GUI type application
	printf("Starting up - please standby .");
	if(!DoInitWithThread()) { printf("\nStartup failed - any key to exit\n"); getch(); return 0; } 
	while(fWaitInit == TRUE)
	{ SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" ."); SleepEx(500, FALSE); printf(" .");   }
	if(!fInitSuccess) { printf("Startup failed - any key to exit\n"); getch(); return 0; } 	

	while(true) {
		if((!EX_SetScanType (usDevID, MULTI_CHAN_CAL_DIGIN_SCAN)) || (!EX_SetMultiChanScanChans (usDevID, 3)) || (!EX_SetDataLogOptions (usDevID, SCAN_USE_DATA_ARRAY, 0, 0))) break; 
		if(!EX_Run (usDevID)) break; fStartSuccess = TRUE; SetCon(); setMainScreen(); break; 
	} if(!fStartSuccess) { printf("Startup failed - any key to exit\n"); getch(); return 0; } 

	while(fRunning)
	{
		EX_CheckScanStatus(usDevID, &puiNumScansRemainingInBuff, &pfStillScanning, &puiStatusCode);
		gotoxy(0,5); printf("Scans in buff: % 3u, StatCode: 0x%03X, StillScanning: %s", puiNumScansRemainingInBuff, puiStatusCode, pfStillScanning > 0 ? "YES" : " NO");
		if(puiNumScansRemainingInBuff > 0)
		{
			// DEVELOPER NOTE: The following will only display the first of however many scans are now ready. You will probably want to display all of the scan data
			uiNumScansToReturn = puiNumScansRemainingInBuff <= (sizeof(pdblDataBuff) / 8) ? puiNumScansRemainingInBuff : puiTotalBuffSize / 8;
			EX_GetScanDataDblDigin (usDevID, pdblDataBuff, pbDiginBuff, uiNumScansToReturn, FALSE, &puiNumScansReturned, &puiNumScansRemainingInBuff, &pfStillScanning, &puiTotalBuffSize, &puiStatusCode); 
			showData(); if(keyChk()) break;
		}
	} return 1;
}




HANDLE	hThread_HANDLE = NULL;
DWORD dwThread_ID;
ULONG ThreadFunc(LPVOID pVoid)
{
	while(true) 
	{
		if(!Init()) break; if(!EX_Connect(&usDevID)) break;
		fInitSuccess = TRUE; break; 
	}
	fWaitInit = FALSE;
	return 0;
}

BOOLEAN DoInitWithThread(void)
{
	hThread_HANDLE = CreateThread(NULL, 0, ThreadFunc, NULL, CREATE_SUSPENDED, &dwThread_ID);
	if(!hThread_HANDLE) return FALSE;
	ResumeThread(hThread_HANDLE);
	return TRUE;
}













//#########################
// Screen support functions
//#########################
void setMainScreen(void)
{ system("cls"); printf("\nINITIALIZED\nPress 'E' to end scanning and exit\n" ); }

void showData()
{
	// DEVELOPER NOTE: Each of the channels below subtract the calibration (offset channel) from the actual voltage
	gotoxy(0,7); printf("chan 0: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[0] - dblDataBuff[7], bDiginBuff[0]);
	gotoxy(0,8); printf("chan 1: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[1] - dblDataBuff[7], bDiginBuff[1]);
	gotoxy(0,9); printf("chan 6: % 2.6lf,  DigitalInput: % 3u", dblDataBuff[2] - dblDataBuff[7], bDiginBuff[2]);
	gotoxy(0,11); printf("offset-channel 7 (for calibration): % 2.6lf", dblDataBuff[3]);
}

BOOLEAN keyChk()
{
	if(_kbhit())
	{
		iKeyChar = getch(); cUserInputVal = (char)iKeyChar;
		if((cUserInputVal == 27) || (cUserInputVal == 'E') || (cUserInputVal == 'e'))
		{
			gotoxy(0,17); printf("Completing scan stop - wait...."); gotoxy(0,16); 
			if(!EX_Stop(usDevID)) printf("failed to stop scan run\n"); 
			else { EX_StopComplete(usDevID); printf("\nScan Stopped. Exiting application - please wait\n"); fRunning = FALSE; }
			cUserInputVal=0; return TRUE;
		}
		else { gotoxy(0,18); printf("\ngot key: %c\n", (char)iKeyChar); }
	}
	return FALSE;
}

BOOLEAN SetCon(void)
{
	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);
	if(!hOutCon)
	{ MessageBox(0, "Error writing to console", "-- error", MB_OK); return FALSE; }
	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon) { MessageBox(0, "Error reading from console", "-- error", MB_OK); return FALSE; }
	ConsoleCursorInfo.dwSize=1; ConsoleCursorInfo.bVisible = TRUE; SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
	return TRUE;
}

BOOLEAN Init()
{  
	hLib301 = LoadLibrary ("LL_USB2k.dll"); if(!hLib301) return FALSE;
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib301, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SetScanType =  (P_DLL_EX_SET_SCAN_TYPE)GetProcAddress(hLib301, "EX_SetScanType");
	if(!EX_SetScanType) return FALSE;
	EX_SetMultiChanScanChans =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS)GetProcAddress(hLib301, "EX_SetMultiChanScanChans");
	if(!EX_SetMultiChanScanChans) return FALSE;
	EX_SetDataLogOptions =  (P_DLL_EX_SET_DATA_LOG_OPTIONS)GetProcAddress(hLib301, "EX_SetDataLogOptions");
	if(!EX_SetDataLogOptions) return FALSE;
	EX_Run =  (P_DLL_EX_RUN)GetProcAddress(hLib301, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_CheckScanStatus = (P_DLL_EX_CHECK_SCAN_STATUS)GetProcAddress(hLib301, "EX_CheckScanStatus");
	if(!EX_CheckScanStatus) return FALSE;
	EX_GetScanDataDblDigin =  (P_DLL_EX_GET_SCAN_DATA_DOUBLE_DIGIN)GetProcAddress(hLib301, "EX_GetScanDataDblDigin");
	if(!EX_GetScanDataDblDigin) return FALSE;
	EX_Stop =  (P_DLL_EX_STOP)GetProcAddress(hLib301, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete =  (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLib301, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;
    return TRUE;
}
